<template>
    <div class="v-select relative" v-click-outside="onClickOutside">
        <label for="first_name" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">{{ label
        }}</label>

        <button v-bind="$attrs" type="button" @click="onClick"
            class="overflow-x-hidden h-[46px] py-2.5 px-5 w-full mr-2 mb-2 text-sm font-medium text-gray-900 focus:outline-none bg-gray-50 rounded-[5px] flex justify-between items-center border border-gray-200 hover:bg-gray-100 hover:text-primary focus:z-10 whitespace-nowrap">
            {{ title }}
            <fa-icon :class="{ 'rotate-180': open }" icon="fa-solid fa-angle-down ml-2" class="duration-500" />
        </button>
        <div v-show="open" class="z-10 bg-white rounded divide-y divide-gray-100 shadow absolute w-full">
            <div v-if="isSearch" class="py-2 px-4">
                <div class="relative">
                    <div class="flex absolute inset-y-0 right-0 items-center pr-3 pointer-events-none">
                        <svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400" fill="currentColor"
                            viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd"
                                d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z"
                                clip-rule="evenodd"></path>
                        </svg>
                    </div>
                    <input
                        class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-full focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5"
                        type="text" v-model="search" />
                </div>
            </div>

            <ul v-if="options.length > 0"
                class="text-sm text-gray-700 dark:text-gray-200 overflow-x-auto max-h-40 scrollbar scrollbar-v"
                aria-labelledby="dropdownDefault">
                <li v-for="(item, i) in options" :key="i">
                    <a @click="open = false; handleChange(item.value);" href="#"
                        class="block overflow-x-hidden py-2 px-4 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white">{{
                                item.name
                        }}</a>
                </li>
            </ul>
            <div class="text-[14px] py-2 px-4 text-gray-700" v-else>No data</div>
        </div>
        <div class="text-danger text-[13px] first-letter:uppercase" v-show="errorMessage || isInvalid">
            {{ errorMessage || errorMessageCustom }}
        </div>
    </div>
</template>

<script>
import { computed, watch, nextTick } from 'vue';
import { useField } from "vee-validate";

export default {
    name: 'VSelect',
    props: {
        items: {
            type: Array,
            default: () => []
        },
        value: {
            type: String,
            default: "",
        },
        name: {
            type: String,
            required: true,
        },
        label: {
            type: String,
            required: true,
        },
        errorMessageCustom: {
            type: String,
            default: "",
        },
        placeholder: {
            type: String,
            default: "",
        },
        isSearch: {
            type: Boolean,
            default: false
        }
    },
    data: () => ({
        open: false,
        search: ''
    }),
    computed: {
        options() {
            return this.isSearch && this.search ? this.items
                .filter(item => item.name.toLowerCase().includes(this.search.toLowerCase())) : this.items;
        }
    },
    methods: {
        onClick() {
            this.open = !this.open;
        },
        onClickOutside() {
            this.open = false;
        }
    },
    setup(props, { emit }) {
        const {
            value: inputValue,
            errorMessage,
            handleBlur,
            handleChange,
            meta,
        } = useField(props.name, undefined, {
            initialValue: props.value,
        });

        const getOptionNameFromValue = (value) => {
            const option = props.items.find(option => option.value === value);
            return option ? option.name : null;
        };

        const title = computed(() => {
            if (inputValue.value) {
                return getOptionNameFromValue(inputValue.value);
            }
            return props.placeholder;
        });

        watch(() => [inputValue.value], (currentValue) => {
            emit("change", currentValue)
        });

        watch(() => [props.items], () => {
            nextTick(() => {
                const option = props.items.find(option => option.value === inputValue.value);
                inputValue.value = option?.value;
                emit("change", inputValue.value);
            })
        });




        return {
            handleChange,
            handleBlur,
            errorMessage,
            inputValue,
            meta,
            title
        };
    },
}
</script>